#include <stdio.h>
#include <tchar.h>
#include <Windows.h>
#include <vector>

HANDLE GetLinkedToken()
{
	HANDLE linked_token;
	HANDLE hToken;
	DWORD dwRetLen;

	OpenProcessToken(GetCurrentProcess(), TOKEN_ALL_ACCESS, &hToken);

	if (GetTokenInformation(hToken, (TOKEN_INFORMATION_CLASS)19, &linked_token, sizeof(linked_token), &dwRetLen))
	{
		printf("Got Token: %p\n", linked_token);

		return linked_token;
	}
	else
	{
		printf("Error: %d\n", GetLastError());
	}

	return NULL;
}

extern "C" LONG NTAPI NtPowerInformation(int level, void* in, unsigned long len, void* out, unsigned long outlen);

int _tmain(int argc, _TCHAR* argv[])
{
	std::vector<char> buf(10 * 1024);

	LONG ret = NtPowerInformation(45, NULL, 0, &buf[0], buf.size());
	
	printf("Call, No Impersonation: %08X\n", ret);
	
	HANDLE hLinked = GetLinkedToken();
	if (hLinked)
	{
		ImpersonateLoggedOnUser(hLinked);
		ret = NtPowerInformation(45, NULL, 0, &buf[0], buf.size());
		printf("Call, Impersonation: %08X\n", ret);
		RevertToSelf();
	}

	return 0;
}
